#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Sep 23 07:30:04 2021

@author: roberto
"""


prova = [-2, 1, -3, 4, -1, 2, 1, -5, 4]

def max_subsequence(a):
    max_sum = float('-inf')
    best_i = 0
    best_j = 0
    for i in range(len(a)):
        my_sum = 0
        for j in range(i,len(a)):
            my_sum += a[j]
            if my_sum > max_sum:
                max_sum = my_sum
                best_i = i
                best_j = j 
    return max_sum, best_i, best_j
                
print(max_subsequence(prova))

def max_subsequence_smart(a):
    max_sum = float('-inf')
    best_start = 0
    best_end = 0
    my_sum = 0
    for end in range(len(a)):
        if my_sum <= 0:
            start = end
            my_sum = a[end]
        else:
            my_sum += a[end]
        if my_sum > max_sum:
            max_sum = my_sum
            best_start = start
            best_end = end
    return max_sum, best_start, best_end

print(max_subsequence_smart(prova))
                
#Given the list: l = [12, 3, -4, 6, -5, 9]
#Given the dictionary:
#d = {’apple’:3, ’orange’:4, ’tomato’:-5, ’meat’:6, ’potato’:15, ’strawberry’:9}
#If a value in the dictionary is found in the list, add the corresponding key to a string named ’to-buy’ and print it at the end.
#If a value in the dictionary is not found in the list, chose another value in the list, that is not present in the dictionary, and assign it to the corresponding key. Print the updated dictionary at the end.
l = [12, 3, -4, 6, -5, 9]
d = {"apple":3, "orange":4, "tomato":-5, "meat":6, "potato":15,  "strawberry":9}
result_string = ""
i = 0

d_values = d.values()

for key in d:
    d_val = d[key]
    if d_val in l:
        result_string += key + ", "
    else:
        found = False
        while (i < len(l) and not found):
            number = l[i]
            if l[i] not in d_values:
                found = True
                d[key] = number
            i += 1
            
            
#pearson correlation
a = [12, 3, 4, 6, 5, 9] 
b = [10, 3, 2, 6, 3, 7]

from numpy import mean
from math import sqrt

def pearson_correlation(X, Y):
    mean_X = mean(X)
    mean_Y = mean(Y)
    sum_X = sum_Y = 0
    cov = 0
    for x in X:
        sum_X += (x - mean_X)**2
    for y in Y:
        sum_Y += (y - mean_Y)**2
    for x,y in zip(X,Y):
        cov += (x - mean_X)*(y - mean_Y)
    coefficient = cov / (sqrt((sum_X)*(sum_Y)))
    return coefficient

print(pearson_correlation(a,b))







